const THREE = await import('https://cdn.skypack.dev/three@0.130.0');
const { OrbitControls } = await import('https://cdn.skypack.dev/three@0.130.0/examples/jsm/controls/OrbitControls.js');
//import * as THREE from 'three';
//const { OrbitControls } = import('https://cdn.skypack.dev/three@0.130.0/examples/jsm/controls/OrbitControls.js');
//import retObjActif from "./kandisky.js" ;
let width = 800;

let height = 600;

export function upDate3D(){
	width=window.innerWidth;
	height=window.innerHeight;
	return width;
}
const scene = new THREE.Scene();
scene.background = new THREE.Color(0x001b42);

var sph;
  
const loader = new THREE.CubeTextureLoader();
loader.setPath( './images/png/' );

var planTexture = new THREE.TextureLoader().load("./images/png/grille3b.png");

const material = new THREE.MeshBasicMaterial({
 color: 0xffffff,
 //envMap: textureCube
  });
  
var camera = new THREE.PerspectiveCamera(75,window.innerWidth/window.innerHeight,0.1,
1000);
var renderer = new THREE.WebGLRenderer();
renderer.setSize( window.innerWidth, window.innerHeight );
 const controls = new OrbitControls(camera, renderer.domElement);
  controls.addEventListener("change", () => renderer.render(scene, camera));
document.body.appendChild(renderer.domElement);

camera.position.z=5;

export function drawDObjActif(obj){
	//let obj=window.opener.retObjActif();
	console.log(obj);
	var lscale=(1-obj.spZ)/2;
	
	lscale=1;
	if (obj.gain<0.30){
		var ws=0.08*lscale;
		var im="0xf4f5d7";
	}
	if (obj.gain>=0.30 && obj.gain<0.60){
		var ws=0.10*lscale;
		var im="0xdcca4e";
	} 
	if (obj.gain>=0.60 && obj.gain<0.90){
		var ws=0.10*lscale;
		var im="0xbaf651";
	}
	if (obj.gain>=0.90 && obj.gain<1.10){
		var ws=0.1*lscale;
		var im="color: 0x1fc535";
	}
	if (obj.gain>=1.10 && obj.gain<1.5){
		var ws=0.2*lscale;
		var im="0xeefc07";
	}
	if (obj.gain>=1.5 && obj.gain<2.0){
		var ws=0.25*lscale;
		var im="0xdc07fc";
	}
	if (obj.gain>=2.0){
		var ws=0.28*lscale;
		var im="0xff0000";
	}
	var sphGeo= new THREE.SphereGeometry(ws,20,20);
	var sphMat = new THREE.MeshBasicMaterial( {color: 0x1fc535} );
	sph = new THREE.Mesh(sphGeo,sphMat);
	const p = new THREE.Vector3( obj.spX,obj.spY,obj.spZ );
	sph.position.set ( obj.spX*3,-obj.spY*2,-obj.spZ*3 );
	scene.add(sph);
	console.log("objdef",im,obj.id);
}

export function moveDObjActif(obj){
	const p = new THREE.Vector3( obj.spX,obj.spY,obj.spZ );
	sph.position.set ( obj.spX*3,-obj.spY*2,-obj.spZ*3 );
	console.log("move",obj.id);
}


const box = new THREE.Box3();
box.setFromCenterAndSize( new THREE.Vector3( 0,0,0 ), new THREE.Vector3( 6, 4, 6 ) );
const helper = new THREE.Box3Helper(box, material);
scene.add(helper);

const planGeometry = new THREE.PlaneGeometry( 6, 4 );
const planMaterial = new THREE.MeshBasicMaterial( {color: 0xffff00, map: planTexture} );
const plane = new THREE.Mesh( planGeometry, planMaterial );
plane.position.set ( 0,0,-3 );
scene.add( plane );
const planGeometry2 = new THREE.PlaneGeometry( 6, 6);
const planMaterial2 = new THREE.MeshBasicMaterial( {color: 0x488df5, map: planTexture} );
const plane2 = new THREE.Mesh( planGeometry2, planMaterial2 );
plane2.position.set ( 0,-2,0 );
rotateObject(plane2, 270, 0, 0);
scene.add( plane2 );
const planGeometry3 = new THREE.PlaneGeometry( 6, 4);
const planMaterial3 = new THREE.MeshBasicMaterial( {color: 0xff0000, map: planTexture} );
const plane3 = new THREE.Mesh( planGeometry3, planMaterial3 );
plane3.position.set ( 3,0,0 );
rotateObject(plane3, 0, 270, 0);
scene.add( plane3 );
function rotateObject(object, degreeX=0, degreeY=0, degreeZ=0) {
   object.rotateX(THREE.Math.degToRad(degreeX));
   object.rotateY(THREE.Math.degToRad(degreeY));
   object.rotateZ(THREE.Math.degToRad(degreeZ));
}
export function onWindowResize(){

    camera.aspect = window.innerWidth / window.innerHeight;
    camera.updateProjectionMatrix();

    renderer.setSize( window.innerWidth, window.innerHeight );

}

function render() {
requestAnimationFrame(render);
renderer.render(scene, camera);
}
render();